#include "log.h"

int flog = 0;

int open_log()
{
  int i = 0;
  char buffer[100];

	/* syslogd logging */
	openlog("nooks-agent", LOG_NDELAY, LOG_KERN);
	
	for (i = 0; i< 1000000; i++) {
	  
	  /* nooks-agent specific logging */
	  sprintf(buffer,"/tmp/nooks-agent.%d",i);
	  flog = open(buffer, O_RDONLY);
	  if (flog >= 0) {
	    close(flog);
	  } else {
	    flog = creat(buffer, O_CREAT | O_EXCL);
	    if (flog >= 0) {
	      break;
	    }
	  }
	}
	return flog;
}

int close_log()
{
	/* close syslogd */
	closelog();
	/* close nooks-agent log */
	return close(flog);
}

int flush_log()
{
	return fsync(flog);
}

int appendlog(char * str)
{
	return write(flog, str, strlen(str));
}

int writelog(const char *fmt, ...)
{
	int err;
	size_t len;
	struct timeval timestamp;
	va_list args;
	static char nooks_w_printk_buf[1024];

	gettimeofday(&timestamp, NULL);
	len = sprintf(nooks_w_printk_buf, "%010ld:%06ld ",
		      timestamp.tv_sec, timestamp.tv_usec);
	err = write(flog, nooks_w_printk_buf, len);

	va_start(args, fmt);
	vsnprintf(nooks_w_printk_buf, sizeof(nooks_w_printk_buf), fmt,
		  args);
	va_end(args);
	err = write(flog, nooks_w_printk_buf, strlen(nooks_w_printk_buf));

	//  fsync(flog);
	return (err);
}

void syslog_fault() {

	int i;
	char buffer[1024];

	memset(buffer, 0, sizeof(buffer));

	strcat(buffer, "the nook ");
	strcat(buffer, nook_name);
	strcat(buffer, " (");
	
	for(i = 0; i < driver_count; i++) {
		strcat(buffer, drivers[i].name);
		strcat(buffer, ", ");
	}
	strcat(buffer, ") faulted\n");

	syslog(LOG_WARNING, buffer);
}

void syslog_recover() {

	syslog(LOG_NOTICE, "Nooks recovered the system\n");

}
